######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..8\n"; };
END {print "not ok 1\n" unless $loaded;}
use Math::Quaternion qw(qtrn);
$loaded = 1;
print "ok 1\n";

######################### End of black magic.

use Config;
$^W = 1;

my $re_1 = qtrn(1);
my $im_i = qtrn(0, 1);
my $im_j = qtrn(0, 0, 1);
my $im_k = qtrn(0, 0, 0, 1);
my $ones = qtrn(1, 1, 1, 1);
my $unit = qtrn(0.5, 0.5, 0.5, 0.5);

my $q1 = qtrn(2, 3, 5, 7);
my $q1_squared = qtrn(-79, 12, 20,  28);

my $q2 = $q1_squared/$q1;
print "not" if ("$q2" ne "2 + 3i + 5j + 7k");
print "ok 2\n";

my $q3 = $q2;
$q3 /= $im_i;
print "not" if ("$q3" ne "3 + -2i + -7j + 5k");
print "ok 3\n";

my $q4 = $q2;
$q4 /= $im_j;
print "not" if ("$q4" ne "5 + 7i + -2j + -3k");
print "ok 4\n";

my $q5 = $q2;
$q5 /= $im_k;
print "not" if ("$q5" ne "7 + -5i + 3j + -2k");
print "ok 5\n";

my $q6 = qtrn(-13, 3, 11, 7) / $ones;
print "not" if ("$q6" ne "2 + 3i + 5j + 7k");
print "ok 6\n";

my $q7 = qtrn(-6, 1, 5, 3) / $unit;
print "not" if ("$q7" ne "1.5 + 2.5i + 4.5j + 6.5k");
print "ok 7\n";

my $q8 = qtrn(-6, 3, 1, 5) / $unit;
print "not" if ("$q8" ne "1.5 + 6.5i + 2.5j + 4.5k");
print "ok 8\n";

1;
